package models

import (
	"fmt"
	_ "github.com/go-sql-driver/mysql" // Because.
	"github.com/go-xorm/core"
	"github.com/go-xorm/xorm"
)

var x *xorm.Engine

func getEngine() (*xorm.Engine, error) {
	connStr := fmt.Sprintf("%s:%s@tcp(%s)/%s?charset=utf8&parseTime=true",
		Config.Database.User, Config.Database.Password, Config.Database.Host, Config.Database.Database)
	return xorm.NewEngine("mysql", connStr)
}

// SetEngine sets the xorm.Engine
func SetEngine() (err error) {
	x, err = getEngine()
	if err != nil {
		return fmt.Errorf("Failed to connect to database: %v", err)
	}

	x.SetMapper(core.GonicMapper{})

	// Sync dat shit
	x.Sync(&Book{})
	x.Sync(&User{})
	x.Sync(&Publisher{})
	x.Sync(&Author{})
	x.Sync(&AuthorBook{})
	x.Sync(&Status{})
	x.Sync(&Quantity{})
	x.Sync(&quantityRelation{})
	x.Sync(&Item{})

	x.ShowSQL(Config.Database.ShowQueries)

	// Check if the first user already exists, aka a user with the ID = 1. If not, insert it
	_, exists, err := GetUserByID(1)
	if err != nil {
		return err
	}

	// If it doesn't exist, create it
	if !exists {
		_, err = CreateUser(Config.FirstUser)
		if err != nil {
			return err
		}
		fmt.Println("Created new user " + Config.FirstUser.Username)
	}

	return nil
}
